{
   gdidemo (by Dejan Boras)
   This program is public domain.

   This program demonstrates gamma functionality under Windows.

   Started On:    21.10.2010.
   Last Update:   21.10.2010.
}

{$MODE OBJFPC}{$H+}
PROGRAM windemo;

USES windows;

{our gamma ramp type}
TYPE
   TGammaRamp = array[0..2, 0..255] of word;

VAR
   {device context handle, used to store a handle to the desktop device context}
   DC: HDC;
   {here we'll store the original gamma ramp}
   storedgamma,
   {this is the new gamma ramp which we'll set}
   ramp: TGammaRamp;

   {for converting string to number}
   code,
   {used for computing the ramp values}
   idx: longint;
   v: dword;
   {the gamma value(factor) we'll set}
   gammavalue: single = 0.5;

BEGIN
   {get the desktop device context}
   DC := GetDC(0);
   if(DC = 0) then begin
      writeln('Failed to get desktop device context.');
   end;

   {get the gamma value parameter}
   val(ParamStr(1), gammavalue, code);
   if(code = 0) then begin
      writeln('Using gamma value(factor): ', gammavalue:0:2);
   end else begin
      if(ParamStr(1) <> '') then
         writeln('Invalid gamma value specified. Value must be in range: -1.0 to 1.0');
   end;

   {store the previous gamma}
   if(GetDeviceGammaRamp(DC, storedgamma) <> true) then
      writeln('Failed to store the gamma ramp.');

   {compute the new gamma ramp}
   for Idx := 0 to 255 do begin
      v := round(idx*((gammavalue*0.5+0.5)*255+128));
      if(v > 65535) then v := 65535;
      ramp[0][Idx] := word(v);
      ramp[1][Idx] := word(v);
      ramp[2][Idx] := word(v);
   end;

   {set the new gamma ramp}
   if(SetDeviceGammaRamp(DC, ramp) <> true) then
      writeln('Failed to set the new gamma ramp.');

   {wait for the user}
   writeln('Press ENTER to continue and restore original gamma...');
   readln();

   {restore the original gamma ramp}
   if(SetDeviceGammaRamp(DC, storedgamma) <> true) then
      writeln('Failed to restore the original gamma ramp.');
END.

